// BitmapOpenAndSaveDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "BitmapOpenAndSave.h"
#include "BitmapOpenAndSaveDlg.h"
#include "MovingPixels.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg-Dialogfeld fr Anwendungsbefehl "Info"

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialogfelddaten
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung

// Implementierung
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CBitmapOpenAndSaveDlg-Dialogfeld




CBitmapOpenAndSaveDlg::CBitmapOpenAndSaveDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBitmapOpenAndSaveDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CBitmapOpenAndSaveDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_BITMAP_PLOT, m_WndBitmapPlot);
}

BEGIN_MESSAGE_MAP(CBitmapOpenAndSaveDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON_QUIT, &CBitmapOpenAndSaveDlg::OnBnClickedButtonQuit)
	ON_BN_CLICKED(IDC_BUTTON_BMP_GENERATE, &CBitmapOpenAndSaveDlg::OnBnClickedButtonBmpGenerate)
	ON_BN_CLICKED(IDC_BUTTON_BMP_LOAD, &CBitmapOpenAndSaveDlg::OnBnClickedButtonBmpLoad)
	ON_BN_CLICKED(IDC_BUTTON_BMP_SAVE, &CBitmapOpenAndSaveDlg::OnBnClickedButtonBmpSave)
END_MESSAGE_MAP()


// CBitmapOpenAndSaveDlg-Meldungshandler

BOOL CBitmapOpenAndSaveDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	CRect rc=m_WndBitmapPlot.GetSize();
	m_WndBitmapPlot.SetSize(rc.Width(), rc.Height());
	m_WndBitmapPlot.SetPlotDataSize(rc.Width(),rc.Height());
	PixelArray.SetSize(rc.Width(),rc.Height());

	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

void CBitmapOpenAndSaveDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}


void CBitmapOpenAndSaveDlg::OnPaint()
{
		CDialog::OnPaint();
}

// Die System ruft diese Funktion auf, um den Cursor abzufragen, der angezeigt wird, whrend der Benutzer
//  das minimierte Fenster mit der Maus zieht.
HCURSOR CBitmapOpenAndSaveDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CBitmapOpenAndSaveDlg::OnBnClickedButtonQuit()
{
	PostQuitMessage(0);
}

void CBitmapOpenAndSaveDlg::OnBnClickedButtonBmpGenerate()
{	
	CRect rc=m_WndBitmapPlot.GetSize();
	PixelArray.SetSize(rc.Width(),rc.Height());
	m_WndBitmapPlot.SetPlotDataSize(rc.Width(),rc.Height());

	PixelArray.IterateNewContent();
	m_WndBitmapPlot.SetPlotData(PixelArray.GetArray());	
	m_WndBitmapPlot.UpdatePlot();			
}

void CBitmapOpenAndSaveDlg::OnBnClickedButtonBmpLoad()
{
	//Display the "Load" dialog for the user to specify a path name
	CFileDialog dlg(
		TRUE,
		"*.bmp", 
		"*.bmp", 
		OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, 
		"Bitmap (*.bmp)", 
		NULL);
	
	if(dlg.DoModal() == IDOK)
	{
		CString szPathName = dlg.GetPathName();
		m_WndBitmapPlot.LoadBitmap(szPathName);
		//m_WndBitmapPlot.LoadBitmapData(szPathName);	
		//m_WndBitmapPlot.UpdatePlot();			
	}		
}

void CBitmapOpenAndSaveDlg::OnBnClickedButtonBmpSave()
{
	//Display the "Save As" dialog for the user to specify a path name
	CFileDialog dlg(
		FALSE,
		"*.bmp", 
		"*.bmp", 
		OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, 
		"Bitmap (*.bmp)", 
		NULL);
	if(dlg.DoModal() == IDOK)
	{
		CString szPathName = dlg.GetPathName();
		m_WndBitmapPlot.SaveBitmap(szPathName);
	}		
}
