#include "stdafx.h"
#include "GraphCtrl.h"


CGraphCtrl::CGraphCtrl(void)
{
	// Set Number of Datamember to 0
	m_PixelNumberX=0;
	m_PixelNumberY=0;	
}

CGraphCtrl::CGraphCtrl(const int x, const int y)
{
	SetPlotDataSize(x,y);
}

CGraphCtrl::~CGraphCtrl(void)
{
}


BEGIN_MESSAGE_MAP(CGraphCtrl, CStatic)
	//{{AFX_MSG_MAP(CGraphCtrl)
	ON_WM_ERASEBKGND()
	ON_WM_PAINT()	
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGraphCtrl message handlers

BOOL CGraphCtrl::OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CStatic::OnNotify(wParam, lParam, pResult);
}


LRESULT CGraphCtrl::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CStatic::WindowProc(message, wParam, lParam);
}

BOOL CGraphCtrl::OnEraseBkgnd(CDC* pDC) 
{	
	return FALSE;	
}


void CGraphCtrl::OnPaint() 
{
	CPaintDC dc(this); // device context for painting	
	
	CRect (rc_dest);
	rc_dest=GetSize();

	CRect (rc_source);
	rc_source=GetPlotDataSize();

	CMemDC pDC(&dc,&rc_source, &rc_dest); // Double Buffering
	PlotToDC(& pDC);
}

void CGraphCtrl::PlotToDC(CMemDC* pDC)
{
	COLORREF c;
	if  ((m_PixelNumberX>0) && (m_PixelNumberY > 0))
	{
		for (int ix=0; ix < m_PixelNumberX; ix++)
		{
			for (int iy=0; iy < m_PixelNumberY; iy++)
			{
				c=PlotData[ix][iy];
				pDC->SetPixel(ix,iy,c);
			}
		}
	}
}
void CGraphCtrl::PlotToDC(CPaintDC* pDC)
{
	COLORREF c;
	if  ((m_PixelNumberX>0) && (m_PixelNumberY > 0))
	{
		for (int ix=0; ix < m_PixelNumberX; ix++)
		{
			for (int iy=0; iy < m_PixelNumberY; iy++)
			{
				c=PlotData[ix][iy];
				pDC->SetPixel(ix,iy,c);
			}
		}
	}
}


void CGraphCtrl::Resize(const unsigned short width, const unsigned short height)
{	
	SetWindowPos(NULL, 0, 0, width, height, SWP_NOMOVE | SWP_NOACTIVATE | SWP_NOZORDER);
}

void CGraphCtrl::FullResize(const CRect newRect)
{
    SetWindowPos(NULL, newRect.left, newRect.top, newRect.right, newRect.bottom, SWP_NOACTIVATE | SWP_NOZORDER);
}


void CGraphCtrl::SetSize(const unsigned short width, const unsigned short height)
{
	Resize(width-1, height-1);
}
CRect CGraphCtrl::GetSize()
{
	CRect rc;
	GetClientRect(rc);		
	return rc;
}

CRect CGraphCtrl::GetPlotDataSize()
{
	CRect rc(0,0,m_PixelNumberX, m_PixelNumberY);
	return rc;
}


void CGraphCtrl::SetPlotDataSize(const int x, const int y)
{
	m_PixelNumberX = x;
	m_PixelNumberY = y;
	if ((x>=0) && (y>=0))
	{		
		PlotData.resize(m_PixelNumberX); 
		for(int x = 0; x < m_PixelNumberX; x++) 
			PlotData[x].resize(m_PixelNumberY); 
	}
}

void CGraphCtrl::SetPlotData(vector<vector<COLORREF> > InputArray)
{	
	if  ((m_PixelNumberX>0) && (m_PixelNumberY > 0))
	{
		PlotData = InputArray;
	}
}

void CGraphCtrl::UpdatePlot()
{		
	Invalidate();
	UpdateWindow();	
}


BOOL CGraphCtrl::SaveBitmap(CString csFileName)
{
	CPaintDC dc(this);
	PlotToDC(&dc);
	BOOL Result = BitmapOperations.SaveDcToBitmapFile((LPCTSTR)csFileName, &dc, GetSize());
	return Result;
}

BOOL CGraphCtrl::LoadBitmap(CString csFileName)
{
	BOOL Result = LoadBitmapData(csFileName);	
	if (Result==FALSE)
		return Result;
	UpdatePlot();
	return Result;
}

BOOL CGraphCtrl::LoadBitmapData(CString csFileName)
{
	CBitmap DrawMeBmp;
	BOOL Result = BitmapOperations.LoadBitmapFileToCBitmap((LPCTSTR)csFileName, DrawMeBmp, NULL );
	if (Result==FALSE)
		return Result;
	Result = BitmapOperations.GetBitmapPixels(DrawMeBmp);
	if (Result==FALSE)
		return Result;
	
	BITMAP bmpInfo;
    DrawMeBmp.GetBitmap(&bmpInfo);
    
	SetPlotDataSize(bmpInfo.bmWidth, bmpInfo.bmHeight);
	SetPlotData(BitmapOperations.GetBitmapArray());
	return Result;
}